#ifndef KOKTAULU_H_MUKANA
#define KOKTAULU_H_MUKANA
/* Demonstraatioita C-kielen tyypeistä, erityisesti taulukko 
 * Käyttöjärjestelmät -- kevät 2015 / Paavo Nieminen, JYU TTL
 * <paavo.j.nieminen@jyu.fi>
 * 
 * Tehtävä:
 *  
 * - täydennä aliohjelma, jolla voidaan laskea kahden eri taulukon
 *   kaikki alkiot yhteen vastinpareittain siten, että tulos jää
 *   talteen toiseen parametrina annetuista taulukoista. Esim. jos
 *   taulukko A on {1,2,3} ja taulukko B on {4,5,16} niin kutsun
 *   jälkeen taulukko B sisältäisi {5,7,19}.
 *
 */

#include<stdint.h>
#include<stdio.h>
#include<stdbool.h>

/** Laskee taulukoiden alkioparit yhteen ja tallentaa tuloksen b-taulukkoon */
void koktaulu_summa_alkioittain_bhen(const int64_t a[], int64_t b[], int nelem);

/** Palauttaa true, jos nelem ensimmäistä lukua ovat samat*/
bool koktaulu_samansisaltoisia(const int64_t a[], const int64_t b[], int nelem);

/** Alkioiden summa (esimerkki taulukon käytöstä) */
int64_t koktaulu_summa(const int64_t taulukko[], int nelem);

/** Täytä vakioarvolla (esimerkki taulukon käytöstä) */
void koktaulu_tayta(int64_t taulukko[], int nelem, int64_t value);

/** Tulosta haluttuun tietovirtaan (esimerkki taulukosta ja virroista) */
void koktaulu_tulosta(const int64_t taulukko[], int nelem, FILE* fp);

#endif
